@import "@assets/themes/themify.utils.scss";
@import "~/themes.scss";

.Switch {
  font-size: 14px;
  text-rendering: optimizelegibility;
  user-select: none;

  &,
  button,
  label {
    cursor: pointer;
  }

  &-disabled {
    button,
    label {
      cursor: not-allowed !important;
    }
  }

  button {
    all: unset;
    position: relative;
    display: flex;
    align-items: center;
    flex-direction: row;

    &:focus-visible {
      .SwitchLabel {
        text-decoration: underline;
      }
    }
  }

  &-circle {
    button {
      width: 70px;
      height: 30px;
      border-radius: 15px;
      justify-content: flex-end;

      &::after {
        position: absolute;
        left: 4px;
        transition: left 0.2s linear;
        width: 24px;
        height: 24px;
        border-radius: 12.5px;
        content: " ";
      }
    }

    .SwitchLabel {
      margin-left: 8px;
      margin-right: 8px;
    }

    input:checked + button {
      justify-content: flex-start;

      &::after {
        left: calc(100% - 24px - 4px);
        transition: left 0.2s linear;
      }
    }
  }

  &-rectangle {
    button {
      height: 30px;
      width: 100px;
      border-radius: 2px;

      &::after {
        position: absolute;
        width: calc(100% / 2);
        height: 100%;
        border-radius: 2px;
        content: " ";
      }

      &::after,
      .SwitchLabel {
        left: 0;
        transition: left 0.1s linear;
      }
    }

    .SwitchLabel {
      position: absolute;
      text-align: center;
      width: 50px;
      z-index: 2;
    }
  }

  input:checked + button {
    &::after,
    .SwitchLabel {
      left: calc(100% - (100% / 2));
      transition: left 0.1s linear;
    }
  }
}

@include themify("Switch", $themes) {
  font-family: themed("font-family");
  color: themed("field-text");

  &.Switch {
    &-circle {
      input:checked + button {
        background-color: themed("status-focus"); // default

        &-active {
          background-color: themed("status-active");
        }

        &-danger {
          background-color: themed("status-danger");
        }

        &-busy {
          background-color: themed("status-busy");
        }
      }

      button {
        background-color: themed("field-background-editable");

        &::after {
          background-color: themed("icon-active");
        }
      }
    }

    &-rectangle {
      input:checked + button {
        &::after {
          background-color: themed("status-active"); // default
        }

        &-focus::after {
          background-color: themed("status-focus");
        }

        &-danger::after {
          background-color: themed("status-danger");
        }

        &-busy::after {
          background-color: themed("status-busy");
        }
      }

      button {
        background-color: themed("field-background-editable");

        &::after {
          background-color: themed("icon");
        }
      }
    }

    input:disabled + button {
      background-color: themed("field-background-disabled");
      color: themed("field-text-disabled");
      cursor: not-allowed;

      &::after {
        background-color: themed("field-text-disabled");
      }
    }
  }
}
